;NSF HEADER
  .org	$8000
	db	"NESM",$1A	;
	db	1		;Ver.
	db	1		;Number of Songs
	db	1		;Start Song No.
	dw	LOAD		;Load
	dw	INIT		;Init
	dw	PLAY		;Play
  .org	$800E
	db	"TEST_SONG"
	db	0
  .org	$802E
	db	"Izumi."
	db	0
  .org	$804E
	db	"(C)2001 Izumi."
	db	0
  .org	$806E
	dw	16666		;1000000 / (freq of NTSC) sec
	db	0,0,0,0,0,0,0,0 ;Bankswitch Init Values
	dw	20000		;1000000 / (freq of PAL)  sec
	db	%00
;                ||
;                |+-------------- PAL/NTSC
;                +--------------- dual PAL/NTSC tune or not
	db	%010000
;                ||||||
;                |||||+---------- VRC6
;                ||||+----------- VRC7
;                |||+------------ FDS
;                ||+------------- MMC5
;                |+-------------- Namcot106
;                +--------------- FME-07
	db	0,0,0,0
LOAD:
INIT:
	jsr	sound_init
	rts
PLAY:
	jsr	sound_driver
	rts

sound_init
	lda	#%00011111
	sta	$4015
	lda	#$00
	sta	$C1
	lda	#$01
	sta	<$c0
	ldy	#$00
	lda	sound_table,y
	sta	<$e0			;f[^Jnʒu
	iny
	lda	sound_table,y
	sta	<$e1			;f[^Jnʒu

	rts

;B0	K
;C0,C1	^C}[JE^[JE^
;D0,D1	g
;E0,E1@f[^ʒu
;F0,F1@4001.4002pf[^
;-------------------------------------------------------------------------------
sound_driver:
;{Ȃ`lJԂ̂

	dec	<$c0			;JE^炵
;	lda	<$c0			;$COiJE^jǂݍ
;	cmp	#$00			;[h[Jr
	bne	return1			;[ȊOȂJE^炵ĂI
	jsr	sound_data_read		;[ȂTEhǂݍ
	jmp	sound_data_write	;ăf[^o

return1:
	rts
;-------------------------------------------------------------------------------
frequency_set:

	lda	<$B0			;Kf[^ǂݏo
	and	#%00001111		;4bito
	asl	a			;Q{
	tay				;YWX^ֈڂ
	lda	sound_frequency_table,y	;ge[uLowǂݏo
	sta	<$D1			;
	iny				;YP₵
	lda	sound_frequency_table,y	;ge[uHighǂݏo
	sta	<$D0			;

	lda	<$B0			;Kf[^ǂݏo
	lsr	a			;4bito
	lsr	a			;
	lsr	a			;
	lsr	a			;
	beq	freq_end		;[Ȃ炻̂܂܏I
	tay				;
oct_set:
	lsr	<$D0			;IN^[uݒ
	ror	<$D1			;IN^[uݒ
	dey				;
	bne	oct_set			;IN^[uJԂ
freq_end:
	rts
;-------------------------------------------------------------------------------
sound_data_read:
	
	ldy	#$00			;indyp
	lda	[$e0],y			;f[^ǂݍ
;--------------------
;f[^̏Ih[
	cmp	#$FF			;f[^$FFȂJԂƂ
	bne	tsuzuki1		;ꂾƃYFȂ
					;Aʂɂ܂Ȃ
	lda	sound_table,y
	sta	<$e0			;f[^Jnʒu
	iny
	lda	sound_table,y
	sta	<$e1			;f[^Jnʒu
	jmp	sound_data_read

;F؂ւp[`
tsuzuki1:
	cmp	#$FE
	bne	tsuzuki2
	jsr	sound_data_address
	lda	[$e0],y
	sta	$4000
;	sta	<$F0			;$4000pf[^
	jsr	sound_data_address
	lda	[$e0],y
	sta	$4001
;	sta	<$F1			;$4001pf[^
	jsr	sound_data_address
	jmp	sound_data_read

tsuzuki2:
	sta	<$B0			;͂܂
	jsr	sound_data_address
	lda	[$e0],y			;ǂݏo
	sta	<$C0			;ۂ̃JEglƂȂ܂
	jsr	sound_data_address
	jsr	frequency_set		;gZbg
	rts

sound_data_address:
	inc	<$e0			;f[^AhX{P
	bne	return2			;ʂオ
	inc	<$e1			;f[^AhXS̈ʁij{P
return2:
	rts


;-------------------------------------------------------------------------------

sound_data_write:

	lda	<$D1			;Low Write
	sta	$4002
	lda	<$D0			;High Write
	sta	$4003
	rts

;10000110
;----------------------------------------------------------
sound_table:
	dw	data
	dw	sound_channel_2
	dw	sound_channel_3
	dw	sound_channel_4
	
data:
;KȀ
;4bit		
;0 1 2 3 4 5 6 7 8 9 A B C D E F
;C C+D D+E F F+G G+A A+B @\
;4bit
;IN^[u
;$FFDDDf[^GhandJԂ
;$FEDDDFݒi{[܂ށHj
;
;		0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
	db	$FE,%00111111,$%00010111

	db	$40,$50,$3A,$50,$35,$50,$2C,$0A,$28,$0A,$2A,$0A,$2B,$0A,$30,$0A
	db	$33,$0A,$37,$0A,$38,$0A,$40,$50,$3A,$50,$35,$50
	db	$FE,%10101111,$%00010111

	db	$3C,$0A,$38,$0A
	db	$37,$0A,$33,$0A,$30,$0A,$2B,$0A,$2A,$0A,$28,$0A,$25,$0A,$23,$0A
	db	$2C,$0A,$25,$14,$28,$14,$23,$0A,$25,$1E,$20,$1E,$23,$14,$25,$0A
	db	$23,$0A,$2C,$0A,$25,$1E,$28,$14,$30,$1E,$28,$1E,$23,$14,$25,$0A
	db	$23,$0A,$2C,$0A,$25,$14,$28,$14,$23,$0A,$25,$1E,$20,$1E,$23,$14
	db	$25,$0A,$23,$0A,$2C,$0A,$25,$1E,$28,$14,$30,$1E,$28,$1E,$23,$14
	db	$13,$0A,$15,$0A,$18,$0A,$15,$0A,$18,$0A,$1a,$0a,$18,$0a,$1a,$0a
	db	$20,$0a,$1a,$0a,$20,$0a,$23,$0a,$2c,$14,$28,$14,$25,$0a,$23,$0a
	db	$FE,%11101111,$%00010111

	db	$2c,$0a,$25,$14,$28,$14,$23,$0a,$25,$1e,$20,$1e,$23,$14,$25,$0a
	db	$23,$0a,$2c,$0a,$25,$1e,$28,$14,$30,$1e,$28,$1e,$23,$14,$25,$0a
	db	$23,$0a,$2c,$0a,$25,$14,$28,$14,$23,$0a,$25,$1e,$20,$1e,$23,$14
	db	$25,$0a,$23,$0a,$2c,$0a,$25,$1e,$28,$14,$30,$1e,$28,$1e,$23,$14
	db	$25,$1e,$28,$1e,$25,$14,$20,$50,$25,$1e,$28,$1e,$25,$14,$20,$50

	db	$21,$1e,$1a,$1e,$16,$14,$16,$1e,$1a,$1e,$21,$14,$1b,$1e,$18,$1e
	db	$14,$14,$14,$1e,$18,$1e,$1b,$14,$21,$0a,$1a,$0a,$21,$0a,$25,$0a
	db	$21,$0a,$25,$0a,$2a,$0a,$25,$0a,$21,$0a,$25,$0a,$21,$0a,$1a,$0a
	db	$15,$0a,$1a,$0a,$15,$0a,$11,$0a,$16,$1e,$16,$1e,$23,$14,$26,$1e

	db	$FE,%10101111,$%00010111
	db	$25,$1e,$21,$14,$23,$a0,$25,$0a,$23,$0a,$2c,$0a,$25,$14,$28,$14
	db	$23,$0a,$25,$1e,$20,$1e,$23,$14,$25,$0a,$23,$0a,$2c,$0a,$25,$1e
	db	$28,$14,$30,$1e,$28,$1e,$23,$14,$25,$0a,$23,$0a,$2c,$0a,$25,$14
	db	$28,$14,$23,$0a,$25,$1e,$20,$1e,$23,$14,$25,$0a,$23,$0a,$2c,$0a
	db	$FE,%01101111,$%00010111

	db	$25,$1e,$28,$14,$30,$1e,$28,$1e,$23,$14,$25,$a0,$13,$0a,$15,$0a
	db	$18,$0a,$15,$0a,$18,$0a,$1a,$0a,$20,$0a,$1a,$0a,$20,$0a,$23,$0a
	db	$25,$0a,$23,$0a,$25,$0a,$28,$0a,$30,$0a,$28,$0a,$25,$1e,$20,$14
	db	$23,$0a,$1a,$14,$20,$1e,$18,$1e,$23,$14,$15,$0a,$18,$0a,$1a,$0a
	db	$18,$0a,$1a,$0a,$20,$0a,$23,$0a,$20,$0a,$23,$0a,$25,$0a,$28,$0a
	db	$23,$0a,$25,$0a,$28,$0a,$23,$0a,$25,$0a,$20,$1e,$1b,$0a,$1c,$0a
	db	$1a,$0a,$1c,$0a,$18,$0a,$15,$50,$25,$06,$23,$07,$25,$07,$28,$06
	db	$25,$07,$23,$07,$20,$06,$23,$07,$25,$07,$28,$06,$25,$07,$23,$07
	db	$25,$06,$23,$07,$25,$07,$30,$06,$25,$07,$23,$07,$25,$06,$23,$07
	db	$25,$07,$1a,$06,$20,$07,$23,$07,$25,$06,$23,$07,$25,$07,$1a,$06
	db	$20,$07,$23,$07,$25,$06,$23,$07,$25,$07,$1a,$06,$20,$07,$23,$07
	db	$25,$06,$23,$07,$25,$07,$30,$06,$25,$07,$23,$07,$30,$06,$25,$07
	db	$23,$07,$30,$06,$25,$07,$23,$07,$25,$14,$28,$0a,$23,$0a,$2c,$0a
	db	$25,$0a,$20,$14,$23,$14,$25,$0a,$20,$0a,$2c,$0a,$18,$1e,$23,$0a
	db	$25,$0a,$28,$0a,$23,$0a,$25,$0a,$18,$0a,$20,$0a,$23,$5a,$25,$06
	db	$23,$07,$25,$07,$28,$06,$25,$07,$23,$07,$20,$06,$23,$07,$25,$07
	db	$28,$06,$25,$07,$23,$07,$25,$06,$23,$07,$25,$07,$30,$06,$25,$07
	db	$23,$07,$25,$06,$23,$07,$25,$07,$1a,$06,$20,$07,$23,$07,$25,$06
	db	$23,$07,$25,$07,$1a,$06,$20,$07,$23,$07,$25,$06,$23,$07,$25,$07
	db	$1a,$06,$20,$07,$23,$07,$25,$06,$23,$07,$25,$07,$30,$06,$25,$07
	db	$23,$07,$30,$06,$25,$07,$23,$07,$30,$06,$25,$07,$23,$07,$28,$32
	db	$28,$0a,$28,$0a,$28,$0a,$23,$32,$23,$0a,$23,$0a,$23,$0a,$25,$32
	db	$25,$0a,$25,$0a,$25,$0a,$25,$0a,$23,$0a,$2c,$0a,$20,$14,$1b,$0a
	db	$1a,$0a,$18,$0a,$FF



sound_channel_2
	db	$FF
sound_channel_3
	db	$FF
sound_channel_4
	db	$FF

;ge[u
sound_frequency_table:
;		c(0)  d-(1) d(2)  e-(3)
	dw	$06AE,$064E,$05F4,$059E
;		e(4)  f(5)  g-(6) g(7)
	dw 	$054E,$0501,$04B9,$0476
;		a-(8) a(9)  b-(A) b(B)
	dw	$0436,$03F9,$03C0,$038A
	dw	$FFFF

;Special Thanks!!!
;Xox

;t180  fps  data
;1/1 = 80 = $50
;1/2 = 40 = $28
;1/4 = 20 = $14
;1/8 = 10 = $0A
;1/16= 05 = $05
;r̘A 1/12 = 6.667 = $06 $07 $07 320fpsɂȂ[
;F-ZERO [FIRE FIELD]

;O6 L8 T184
;C1<B-1F1 <R8A-B-B>CE-GA->
;40,50,3A,50,35,50,2C,0A,28,0A,2A,0A,2B,0A,30,0A,33,0A,37,0A,38,0A
;C1<B-1F1 R8A-GE-C<BB-A-
;40,50,3A,50,35,50,3C,0A,38,0A,37,0A,33,0A,30,0A,2B,0A,2A,0A,28,0A

;FE-R8F4A-4E- F4.C4.E-4 FE-R8F4.A-4 >C4.<A-4.E-4
;25,0A,23,0A,2C,0A,25,14,28,14,23,0A,25,1E,20,1E,23,14,25,0A,23,0A,2C,0A,25,1E,28,14,30,1E,28,1E,23,14
;FE-R8F4A-4E- F4.C4.E-4 FE-R8F4.A-4 >C4.<A-4.E-4
;25,0A,23,0A,2C,0A,25,14,28,14,23,0A,25,1E,20,1E,23,14,25,0A,23,0A,2C,0A,25,1E,28,14,30,1E,28,1E,23,14

;<E-FA-FA-B-A-B- >C<B->CE-RA-4    FE-R8F&FA-4E- F4.C&C4E-4
;13,0A,15,0A,18,0A,15,0A,18,0A,1a,0a,18,0a,1a,0a,20,0a,1a,0a,20,0a,23,0a,2c,14,28,14
;25,0a,23,0a,2c,0a,25,14,28,14,23,0a,25,1e,20,1e,23,14
;FE-R8F&F4A-4   >C4.<A-&A-4E-4 FE-R8F&FA-4E- F4.C&C4E-4
;25,0a,23,0a,2c,0a,25,1e,28,14,30,1e,28,1e,23,14,25,0a,23,0a,2c,0a,25,14,28,14,23,0a,25,1e,20,1e,23,14
;FE-R8F&F4A-4   >C4.<A-&A-4E-4 F4.A-&A-4F4 C1
;25,0a,23,0a,2c,0a,25,1e,28,14,30,1e,28,1e,23,14,25,1e,28,1e,25,14,20,50

;F4.A-&A-4F4 C1 >D-4.<B-&B-4G-4 G-4.B-&B-4>D-4<
;25,1e,28,1e,25,14,20,50,31,1e,2a,1e,26,14,26,1e,2a,1e,31,14
;B4.A-&A-4E4 E4.A-&A-4B4 >D-<B->D-FD-FB-F D-FD-<B-FB-FD-
;2b,1e,28,1e,24,14,24,1e,28,1e,2b,14,31,0a,2a,0a,31,0a,35,0a,31,0a,35,0a,3a,0a,35,0a
;31,0a,35,0a,31,0a,2a,0a,25,0a,2a,0a,25,0a,21,0a
;G-4.G-&G-4>E-4 G-4.F&F4D-4 E-1 &E-1<
;26,1e,26,1e,33,14,36,1e,35,1e,31,14,33,a0
;FE-R8F&FA-4E- F4.C&C4E-4 FE-R8F&F4A-4 >C4.<A-&A-4E-4
;25,0a,23,0a,2c,0a,25,14,28,14,23,0a,25,1e,20,1e,23,14,25,0a,23,0a,2c,0a,25,1e,28,14,30,1e,28,1e,23,14
;FE-R8F&FA-4E- F4.C&C4E-4 FE-R8F&F4A-4 >C4.<A-&A-4E-4
;25,0a,23,0a,2c,0a,25,14,28,14,23,0a,25,1e,20,1e,23,14,25,0a,23,0a,2c,0a,25,1e,28,14,30,1e,28,1e,23,14
;F1 &F1
;25,a0
;<E-FA-FA-B->C<B->CE-FE-FA- >C<A- F4.C&CE-<B-4> C4.<A-&A-4>E-4
;13,0a,15,0a,18,0a,15,0a,18,0a,1a,0a,20,0a,1a,0a,20,0a,23,0a,25,0a,23,0a,25,0a,28,0a
;30,0a,28,0a,25,1e,20,14,23,0a,1a,14,20,1e,18,1e,23,14
;<FA-B-A-B->CE-C E-FA-E-FA-E-F C4.<BR8B-R8A- F1>
;15,0a,18,0a,1a,0a,18,0a,1a,0a,20,0a,23,0a,20,0a,23,0a,25,0a,28,0a,23,0a,25,0a,28,0a,23,0a,25,0a
;20,1e,1b,0a,1c,0a,1a,0a,1c,0a,18,0a,15,50
;Q6{FE-F A-FE- CE-F A-FE-}1 {FE-F>C<FE-FE-F<B->CE-}1 {FE-F<B->CE-FE-F<B->CE-}1 {FE-F>C<FE->C<FE->C<FE-}1 Q8
;25,06,23,07,25,07,28,06,25,07,23,07,20,06,23,07,25,07,28,06,25,07,23,07
;25,06,23,07,25,07,30,06,25,07,23,07,25,06,23,07,25,07,1a,06,20,07,23,07
;25,06,23,07,25,07,1a,06,20,07,23,07,25,06,23,07,25,07,1a,06,20,07,23,07
;25,06,23,07,25,07,30,06,25,07,23,07,30,06,25,07,23,07,30,06,25,07,23,07
;F4A-E-R8FC4 E-4FCR8<A-4.> E-FA-E-F<A->CE- &E-1
;25,14,28,0a,23,0a,2c,0a,25,0a,20,14,23,14,25,0a,20,0a,2c,0a,18,1e,23,0a,25,0a,28,0a,23,0a,25,0a,18,0a,20,0a,23,5a
;Q6{FE-FA-FE-CE-FA-FE-}1 {FE-F>C<FE-FE-F<B->CE-}1 {FE-F<B->CE-FE-F<B->CE-}1 {FE-F>C<FE->C<FE->C<FE-}1 Q8
;25,06,23,07,25,07,28,06,25,07,23,07,20,06,23,07,25,07,28,06,25,07,23,07
;25,06,23,07,25,07,30,06,25,07,23,07,25,06,23,07,25,07,1a,06,20,07,23,07
;25,06,23,07,25,07,1a,06,20,07,23,07,25,06,23,07,25,07,1a,06,20,07,23,07
;25,06,23,07,25,07,30,06,25,07,23,07,30,06,25,07,23,07,30,06,25,07,23,07
;A-2 &A-A-A-A- E-2 &E-E-E-E- F2 &FFFF FE-R8C&C<BB-A->>>
;28,32,28,0a,28,0a,28,0a,23,32,23,0a,23,0a,23,0a,25,32,25,0a,25,0a,25,0a,25,0a,23,0a,2c,0a,20,14,1b,0a,1a,0a,18,0a
